
Module STLCexp.

  Inductive type : Type :=
  | tvar ((* index *) i : nat)
  | tarrow (A : type) (B : type)
  | tall ((* bind type in *) A : type).

  Inductive term : Type :=
  | app (t1 : term) (t2 : term)
  | lam ((* bind exp in *) t : term)
  | tapp (t : term) (A : type)
  | gen ((* bind type in *) t : term)
  | eterm (e : exp)

  with exp : Type :=
  | var ((* index *) x : nat)
  | int (n : nat)
  | plus (e1 : exp) (e2 : exp)
  | texp (t : term).

End STLCexp.
