
Module LOOPW.

  Inductive mutable : Type :=
  | id ((* index *) x : nat)

  with mutables : Type :=
  | mnil
  | mcons (m : mutable) (ms : mutables).

  Inductive exp : Type :=
  | cvar ((* index *) x : nat)
  | mvar (x : mutable)
  | int (n : nat)
  | proc (n : nat) (m : nat) ((* bind [ n exp ], [ m mutable ] in *) s : seq)

  with exps : Type :=
  | enil
  | econs (e : exp) (es : exps)

  with comm : Type :=
  | assign (x : mutable) (e : exp)
  | inc (x : mutable)
  | dec (x : mutable)
  | block (s : seq)
  | forloop (e : exp) ((* bind exp in *) s : seq)
  | call (p : exp) (es : exps) (ms : mutables)

  with seq : Type :=
  | empty
  | cst (e : exp) ((* bind exp in *) s : seq)
  | var ((* bind mutable in *) s : seq)
  | com (c : comm) (s : seq).

End LOOPW.
